package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Set;
import org.antlr.codegen.CodeGenerator;
import org.antlr.runtime.Token;
import org.antlr.tool.Attribute;
import org.antlr.tool.ErrorManager;
import org.antlr.tool.Grammar;
import org.antlr.tool.GrammarAST;

public class AttributeScope {
  public static final org.antlr.tool.AttributeScope tokenScope = new org.antlr.tool.AttributeScope("Token", null);
  
  public Token derivedFromToken;
  
  public Grammar grammar;
  
  private String name;
  
  public boolean isDynamicGlobalScope;
  
  public boolean isDynamicRuleScope;
  
  public boolean isParameterScope;
  
  public boolean isReturnScope;
  
  public boolean isPredefinedRuleScope;
  
  public boolean isPredefinedLexerRuleScope;
  
  static {
    tokenScope.addAttribute("text", null);
    tokenScope.addAttribute("type", null);
    tokenScope.addAttribute("line", null);
    tokenScope.addAttribute("index", null);
    tokenScope.addAttribute("pos", null);
    tokenScope.addAttribute("channel", null);
    tokenScope.addAttribute("tree", null);
    tokenScope.addAttribute("int", null);
  }
  
  protected LinkedHashMap<String, Attribute> attributes = new LinkedHashMap<String, Attribute>();
  
  public LinkedHashMap<String, GrammarAST> actions = new LinkedHashMap<String, GrammarAST>();
  
  public AttributeScope(String name, Token derivedFromToken) {
    this(null, name, derivedFromToken);
  }
  
  public AttributeScope(Grammar grammar, String name, Token derivedFromToken) {
    this.grammar = grammar;
    this.name = name;
    this.derivedFromToken = derivedFromToken;
  }
  
  public String getName() {
    if (this.isParameterScope)
      return this.name + "_parameter"; 
    if (this.isReturnScope)
      return this.name + "_return"; 
    return this.name;
  }
  
  public void addAttributes(String definitions, int separator) {
    List<String> attrs = new ArrayList<String>();
    CodeGenerator.getListOfArgumentsFromAction(definitions, 0, -1, separator, attrs);
    for (String a : attrs) {
      Attribute attr = new Attribute(a);
      if (!this.isReturnScope && attr.initValue != null) {
        ErrorManager.grammarError(148, this.grammar, this.derivedFromToken, attr.name);
        attr.initValue = null;
      } 
      this.attributes.put(attr.name, attr);
    } 
  }
  
  public void addAttribute(String name, String decl) {
    this.attributes.put(name, new Attribute(name, decl));
  }
  
  public final void defineNamedAction(GrammarAST nameAST, GrammarAST actionAST) {
    String actionName = nameAST.getText();
    GrammarAST a = this.actions.get(actionName);
    if (a != null) {
      ErrorManager.grammarError(144, this.grammar, nameAST.getToken(), nameAST.getText());
    } else {
      this.actions.put(actionName, actionAST);
    } 
  }
  
  public Attribute getAttribute(String name) {
    return this.attributes.get(name);
  }
  
  public List<Attribute> getAttributes() {
    List<Attribute> a = new ArrayList<Attribute>();
    a.addAll(this.attributes.values());
    return a;
  }
  
  public Set<String> intersection(org.antlr.tool.AttributeScope other) {
    if (other == null || other.size() == 0 || size() == 0)
      return null; 
    Set<String> inter = new HashSet<String>();
    Set<String> thisKeys = this.attributes.keySet();
    for (String key : thisKeys) {
      if (other.attributes.get(key) != null)
        inter.add(key); 
    } 
    if (inter.isEmpty())
      return null; 
    return inter;
  }
  
  public int size() {
    return (this.attributes == null) ? 0 : this.attributes.size();
  }
  
  public String toString() {
    return (this.isDynamicGlobalScope ? "global " : "") + getName() + ":" + this.attributes;
  }
}
